/*
 * @file BackupServer_Module_Im.c
 * Module Interface for Module BackupServer_Module_Im
 */

#include "BackupServer_Module_Im.h"

void BackupServer_Module_Im__INITIALIZE__received(BackupServer_Module_Im__context *context)
{
   /* User Code Here */
}

void BackupServer_Module_Im__START__received(BackupServer_Module_Im__context *context)
{
   // Set the service as functionally available.
   BackupServer_Module_Im_container__Available_handle availableHandle;

   ECOA__return_status status = BackupServer_Module_Im_container__Available__get_write_access(context, &availableHandle);

   if (status == ECOA__return_status_OK || status == ECOA__return_status_DATA_NOT_INITIALIZED)
   {
      *(availableHandle.data) = ECOA__TRUE;
      ECOA__return_status status = BackupServer_Module_Im_container__Available__publish_write_access(context, &availableHandle);
   }
}

void BackupServer_Module_Im__STOP__received(BackupServer_Module_Im__context *context)
{
   /* User Code Here */
}

void BackupServer_Module_Im__SHUTDOWN__received(BackupServer_Module_Im__context *context)
{
   /* User Code Here */
}

void BackupServer_Module_Im__Request_for_Val__request_received
   (BackupServer_Module_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__global_time* time)
{
   ECOA__return_status return_status;

   // Add an artificial delay in the backup server (to mimic a slower response time in the non-preferred server).
   int i,j;
   for (i; i <= 500000000; i++)
   {
      while (j <= 500000000)
      {
         j++;
      }
   }

   return_status = BackupServer_Module_Im_container__Request_for_Val__response_send(context, ID, 2);
}
