/*
 * @file NonBrokeredClient_Module_Im.c
 * Module Interface for Module NonBrokeredClient_Module_Im
 */

#include <stdio.h>
#include "NonBrokeredClient_Module_Im.h"

void NonBrokeredClient_Module_Im__INITIALIZE__received(NonBrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void NonBrokeredClient_Module_Im__START__received(NonBrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void NonBrokeredClient_Module_Im__STOP__received(NonBrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void NonBrokeredClient_Module_Im__SHUTDOWN__received(NonBrokeredClient_Module_Im__context *context)
{
   /* User Code Here */
}

void NonBrokeredClient_Module_Im__tick__received(NonBrokeredClient_Module_Im__context *context)
{
   ECOA__return_status return_status;
   ECOA__uint32 requestID;
   example__value_type val = 0;
   ECOA__global_time time;
   ECOA__log log;
   ECOA__boolean8 preferredAvailable = ECOA__FALSE;

   return_status = NonBrokeredClient_Module_Im_container__get_absolute_system_time(context, &time);

   // Use the preferred service provide if available.
   NonBrokeredClient_Module_Im_container__PreferredAvailable_handle preferredAvailableHandle;
   return_status =  NonBrokeredClient_Module_Im_container__PreferredAvailable__get_read_access(context, &preferredAvailableHandle);

   if (return_status == ECOA__return_status_OK)
   {
      if (*(preferredAvailableHandle.data) == ECOA__TRUE)
      {
         preferredAvailable = ECOA__TRUE;
         log.current_size = sprintf((char *) &log.data, "***NonBrokeredClient - using preferred -  val before request = %d", val);
         NonBrokeredClient_Module_Im_container__log_info(context, log);

         return_status = NonBrokeredClient_Module_Im_container__Request_Val_Preferred__request_sync(context, &time, &val);

         log.current_size = sprintf((char *) &log.data, "***NonBrokeredClient - using preferred - val from response = %d", val);
         NonBrokeredClient_Module_Im_container__log_info(context, log);
      }

      return_status =  NonBrokeredClient_Module_Im_container__PreferredAvailable__release_read_access(context, &preferredAvailableHandle);
   }

   // otherwise if the backup is available, use that.
   if (!preferredAvailable)
   {
      NonBrokeredClient_Module_Im_container__BackupAvailable_handle backupAvailableHandle;
      return_status =  NonBrokeredClient_Module_Im_container__BackupAvailable__get_read_access(context, &backupAvailableHandle);

      if (return_status == ECOA__return_status_OK)
      {
         if (*(backupAvailableHandle.data) == ECOA__TRUE)
         {
            log.current_size = sprintf((char *) &log.data, "***NonBrokeredClient - using backup - val before request = %d", val);
            NonBrokeredClient_Module_Im_container__log_info(context, log);

            return_status = NonBrokeredClient_Module_Im_container__Request_Val_Backup__request_sync(context, &time, &val);

            log.current_size = sprintf((char *) &log.data, "***NonBrokeredClient - using backup - val from response = %d", val);
            NonBrokeredClient_Module_Im_container__log_info(context, log);
         }

         return_status = NonBrokeredClient_Module_Im_container__BackupAvailable__release_read_access(context, &backupAvailableHandle);
      }
   }
}

