/*
 * @file PreferredServer_Module_Im.c
 * Module Interface for Module PreferredServer_Module_Im
 */

#include <stdio.h>
#include "PreferredServer_Module_Im.h"

void PreferredServer_Module_Im__INITIALIZE__received(PreferredServer_Module_Im__context *context)
{
   /* User Code Here */
}

void PreferredServer_Module_Im__START__received(PreferredServer_Module_Im__context *context)
{
   // Set the service as functionally available.
   PreferredServer_Module_Im_container__Available_handle availableHandle;

   ECOA__return_status status = PreferredServer_Module_Im_container__Available__get_write_access(context, &availableHandle);

   if (status == ECOA__return_status_OK || status == ECOA__return_status_DATA_NOT_INITIALIZED)
   {
      *(availableHandle.data) = ECOA__TRUE;
      ECOA__return_status status = PreferredServer_Module_Im_container__Available__publish_write_access(context, &availableHandle);
   }
}

void PreferredServer_Module_Im__STOP__received(PreferredServer_Module_Im__context *context)
{
   /* User Code Here */
}

void PreferredServer_Module_Im__SHUTDOWN__received(PreferredServer_Module_Im__context *context)
{
   /* User Code Here */
}

void PreferredServer_Module_Im__Request_for_Val__request_received
   (PreferredServer_Module_Im__context* context,
    const ECOA__uint32 ID,
    const ECOA__global_time* time)
{
   ECOA__return_status return_status;

   // Preferred server responds immediately.
   return_status = PreferredServer_Module_Im_container__Request_for_Val__response_send(context, ID, 1);
}

void PreferredServer_Module_Im__Switch_Availability__received(PreferredServer_Module_Im__context *context)
{
   // Set the service as functionally available.
   ECOA__log log;
   PreferredServer_Module_Im_container__Available_handle availableHandle;

   ECOA__return_status status = PreferredServer_Module_Im_container__Available__get_write_access(context, &availableHandle);

   if (status == ECOA__return_status_OK)
   {
      if (*(availableHandle.data) == ECOA__TRUE)
      {
         log.current_size = sprintf((char *) &log.data, "Preferred server setting service UNAVAILABLE");
         PreferredServer_Module_Im_container__log_info(context, log);
         *(availableHandle.data) = ECOA__FALSE;
      }
      else
      {
         log.current_size = sprintf((char *) &log.data, "Preferred server setting service AVAILABLE");
         PreferredServer_Module_Im_container__log_info(context, log);
         *(availableHandle.data) = ECOA__TRUE;
      }
      ECOA__return_status status = PreferredServer_Module_Im_container__Available__publish_write_access(context, &availableHandle);
   }
}
